/*++

Copyright (c) Sydus.

Module:

    Md5.h

Authors:

    Sharvil Nanavati (sharvil) 2006-08-15

--*/

#pragma once

#include "base.h"

class Md5
{
	private:
		static const uint32 cInitializationVector[4];
		static const uint32 cRotateLookupTable[64];
		static const uint32 cAddLookupTable[64];

	public:
		static const uint32 KHashSize = 16;
		static const uint32 KBlockSize = 64;

		Md5();
		~Md5();

		BString Hash(const BString & data);

		BString Hash();
		Md5 & operator << (const BString & data);

	private:
		void ComputeBlock(const void * dataBlock);
		void ResetState();

		bool iFinalized;
		uint8 iCurrentBlock[64];
		uint32 iCurrentBlockSize;
		uint32 iHash[4];
		uint64 iMessageLength;
};
