/*++

Copyright (c) Sydus.

Module:

    CidrNetmask.h

Authors:

    Sharvil Nanavati (sharvil) 2008-07-31

--*/

#pragma once

#include "base.h"

class InetAddress;
class CidrNetmask
{
	public:
		friend bool operator << (const InetAddress & address, const CidrNetmask & netmask);

		CidrNetmask();
		CidrNetmask(const std::string & ip, uint32 bits);
		CidrNetmask(const InetAddress & ip, uint32 bits);
		explicit CidrNetmask(const std::string & netmask);

		std::string AsString() const;
		operator std::string() const;

	private:
		uint32 iIpHostOrder;
		uint32 iSignificantBits;
};

bool operator << (const InetAddress & address, const CidrNetmask & netmask);
