/*++

Copyright (c) Sydus.

Module:

	Primitive.h

Authors:

	Sharvil Nanavati (sharvil) 2006-08-25

--*/

#pragma once

#include "base.h"

namespace Primitive
{
	template <typename T> T Gcd(T value1, T value2);
	template <typename T> T Rol(T value, uint32 amount);
	template <typename T> T Ror(T value, uint32 amount);

// -------------------------------------------------------------- Implementation

	template <typename T>
	T Gcd(T value1, T value2)
	{
		if(value2 == 0)
			return 0;

		value1 = std::abs(value1);
		value2 = std::abs(value2);

		if(value1 < value2)
			std::swap(value1, value2);

		while(value2 != 0)
		{
			T remainder = value1 % value2;
			value1 = value2;
			value2 = remainder;
		}
		return value1;
	}

	template <typename T>
	T Rol(T value, uint32 amount)
	{
		amount %= sizeof(T) * 8;
		return (value << amount) | (value >> (sizeof(T) * 8 - amount));
	}

	template <typename T>
	T Ror(T value, uint32 amount)
	{
		amount %= sizeof(T) * 8;
		return (value >> amount) | (value << (sizeof(T) * 8 - amount));
	}
}
